;; $Id: deliver.cl,v 1.1.2.5 1999/01/30 18:43:28 layer Exp $

(in-package :user)

(defvar *purify* nil) ;; set in Makefile
(defvar *runtime-type* nil) ;; set in Makefile

(let ((*record-source-file-info* nil)
      (*load-source-file-info* nil)
      (excl::*break-on-warnings* t))
  (compile-file "checklinks.cl"))

(defvar *debug* nil)

(generate-application
 "checklinks"
 "checklinks/" '(;; include these because we're not sure if they're used:
		 :list2 :seq2
		 ;; include these because we know we use them:
		 :sock :process :fileutil
		 "checklinks.fasl")
 :restart-init-function 'main
 #-mswindows
 :application-administration
 #-mswindows ;; Quiet startup (See below for Windows version of this.)
 '(:resource-command-line "-Q")
 :read-init-files nil
 :print-startup-message nil

 :purify (and (null *debug*) *purify*)
 :runtime (and (null *debug*) *runtime-type*)

 :include-debugger *debug*
 :include-tpl *debug*
 :include-compiler nil
 :include-devel-env nil
 :include-ide nil
 :discard-arglists (null *debug*)
 :discard-local-name-info (null *debug*)
 :discard-source-file-info (null *debug*)
 :discard-xref-info (null *debug*)
 
 ;; debugging:
 :internal-debug "build.in"
 :dribble-file "build.out"
 
 ;; dumplisp arguments:
 :ignore-command-line-arguments t
 :suppress-allegro-cl-banner t)

#+mswindows ;; Quiet startup:
(run-shell-command
 (format nil "\"~a\" -o checklinks/checklinks.exe -Q"
	 (translate-logical-pathname "sys:bin;setcmd.exe")))

(exit 0)
