(in-package :user)

(defun factorial (x)			; assumes caller will trap errors
  (cond
   ((= x 0) 1)
   (t (* x (factorial (1- x))))))

(eval-when (load)
  ;; on Solaris and Dec Alpha, a crash will occur if a library linked with
  ;; the pthread library is loaded twice in one session
  (when (dolist (lib (excl::foreign-files) t)
	  (when (string= #+hpux "libfact.sl" #-hpux"libfact.so" 
			 (namestring lib))
	    (return nil)))
    (load #+hpux "libfact.sl" #-hpux"libfact.so")))

(ff:def-foreign-call set_factorial_callback (address))

(ff:def-foreign-call release_end_semaphore ())

(ff:def-foreign-call wait_for_work ())

(ff:def-foreign-call copy_factorial_result 
    ((str1 :unsigned-long) (str2 (* :char)) (n :int)))

(ff:defun-c-callable (factorial-callback :c)
    ((arg :unsigned-long) (string :unsigned-long) (length :unsigned-long))
  :long
  (handler-case
      (progn
	(copy_factorial_result string
			     (format nil "~s" (factorial arg))
			     length)
	0) ;; return 0 if successful
    (serious-condition ()
      -1)) ;; return -1 if unsuccessful
  )

(defun initialize-factorial ()
  (set_factorial_callback (ff:register-function #'factorial-callback nil t))
  (release_end_semaphore)
  (wait_for_work)
  (exit))

(setf excl:*restart-init-function* #'initialize-factorial)