#include <stdio.h>
#include <string.h>
#include <ctype.h>

#ifdef __hpux
extern "C" {
#endif

void usage();
#ifdef __hpux
#include <stdlib.h>
int initialize_factorial( char ** );
int factorial( unsigned int, char *, int );
int terminate_factorial();
#endif

int
main( int argc, char *argv[], char **envp )
{
    int i, n, ret;
    char result_string[4096];

    if (argc != 2)
    {
    	usage();
	exit( 1 );
    }
    if (strlen( argv[1] ) > 3 )
    {
    	usage();
	exit( 1 );
    }
    for (i = 0; *(argv[1] + i); i++)
    {
    	if (!isdigit( *(argv[1] + i) ))
	{
	    usage();
	    exit( 1 );
	}
    }
    sscanf( argv[1], "%d", &n );
    if (
#ifndef AIX
	initialize_factorial( envp )
#else
	do_initialize_factorial( envp )
#endif
	!= 0)
    {
    	fprintf(stderr, "factorial startup error\n" );
	exit( 1 );
    }
    if ((ret = factorial( n, result_string, 4096 )) != 0)
    {
    	fprintf(stderr, "factorial internal error\n" );
	exit( 1 );
    }
    printf( "%s\n", result_string );
    printf( "repeating calculation to show multiple calls work...\n");
    result_string[0] = '\0';
    if ((ret = factorial( n, result_string, 4096 )) != 0)
    {
    	fprintf(stderr, "factorial internal error\n" );
	exit( 1 );
    }
    printf( "%s\n", result_string );
    terminate_factorial();
    return 0;
}

void
usage()
{
    fprintf( stderr, "usage: ftest n, where n is an integer between 0 and 999\n" );
}
#ifdef __hpux
};
#endif


#ifdef AIX
#include <pthread.h>

static pthread_t tid;
static pthread_attr_t pattr;

void *lisp_init_func();

int
do_initialize_factorial( char **envp )
{
    initialize_factorial();
    if (pthread_attr_init( &pattr ) != 0) return -1;
    if (pthread_attr_setstacksize( &pattr, 1024*1024 ) != 0) return -1;
    if (pthread_create( &tid, 
			&pattr, 
			(void *(*)(void *)) lisp_init_func(),
			(void *) 0) != 0) return -1;
    wait_on_end_semaphore();
    return 0;
}
#endif /* AIX */
